﻿Imports System.Windows.Forms
Imports System.IO
Imports System.Drawing, System.Drawing.Drawing2D

Public Class frmDrawingPerform
	Private _Center, _CirclePoints As PointF(), _mtr As New Matrix
	Private nCirclePoints% = 100
	Public ZeichenFlaeche As New Bitmap(5, 5)


	Private Sub _Canvas_SizeChanged(sender As Object, e As EventArgs)
		'Zeichnung einrichten - abgestimmt auf Grösse des Canvas
		ZeichenFlaeche.Dispose()
		ZeichenFlaeche = New Bitmap(_Canvas.Width, _Canvas.Height)
		_mtr.Reset()
		_Center = {New PointF, New PointF(0.75F, 0)}
		Dim pt = New PointF(1, 0)
		_CirclePoints = New PointF(nCirclePoints - 1) {}
		_mtr.RotateAt(360.0F / nCirclePoints, PointF.Empty)
		For i = 0 To nCirclePoints - 1
			_CirclePoints(i) = pt : _mtr.TransformPoints(_CirclePoints)
		Next
		Dim l = (Math.Min(_Canvas.Width, _Canvas.Height) - 5.0F) / 2.0F
		_mtr.Reset()
		_mtr.Translate(l, l) : _mtr.Scale(l, l) : _mtr.TransformPoints(_CirclePoints) : _mtr.TransformPoints(_Center)
		_mtr.Reset()
		_mtr.RotateAt(2, _Center(0))
	End Sub

	Private Sub ckBackgroundBitmap_CheckedChanged(sender As Object, e As EventArgs) Handles ckBackgroundBitmap.CheckedChanged
		_Canvas.BackgroundImage = If(ckBackgroundBitmap.Checked, ZeichenFlaeche, Nothing)
		_Canvas.Invalidate()
	End Sub

	Private Sub frmDrawingPerform_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
		AddHandler Canvas.SizeChanged, AddressOf _Canvas_SizeChanged
		AddHandler Canvas.Paint, AddressOf _Canvas_Paint
		_Canvas_SizeChanged(Nothing, Nothing)
	End Sub

	Private Sub _Canvas_Paint(sender As Object, e As PaintEventArgs)
		If ckBackgroundBitmap.Checked Then Zeichne(Canvas) Else Draw(e.Graphics) : Canvas.Invalidate()
	End Sub

	Public Sub Zeichne(PNL As Control)
		PNL.BackgroundImage = Nothing
		Using g As Graphics = Graphics.FromImage(ZeichenFlaeche)
			g.Clear(Color.Black)
			'hier weitere Ausgaben mit g.DrawLine, g.DrawString etc. ausführen
			Draw(g)
		End Using
		'Gezeichnete Bitmap auf das Panel zurückschreiben
		PNL.BackgroundImage = ZeichenFlaeche
	End Sub

	Private Sub Draw(g As Graphics)
		g.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
		g.CompositingQuality = Drawing2D.CompositingQuality.HighQuality
		_mtr.TransformPoints(_Center)
		For i = 0 To nCirclePoints - 1
			g.DrawLine(Pens.Red, _Center(1), _CirclePoints(i))
		Next
	End Sub
End Class